/*! cal-heatmap v3.3.10 (Tue Dec 03 2013 19:30:01)
 *  ---------------------------------------------
 *  Cal-Heatmap is a javascript module to create calendar heatmap to visualize time series data
 *  https://github.com/kamisama/cal-heatmap
 *  Licensed under the MIT license
 *  Copyright 2013 Wan Qi Chen
 */
var CalHeatMap=function(){"use strict";var self=this;for(var type in this.allowedDataType=["json","csv","tsv","txt"],this.options={itemSelector:"#cal-heatmap",paintOnLoad:!0,range:12,cellSize:10,cellPadding:2,cellRadius:0,domainGutter:2,domainMargin:[0,0,0,0],domain:"hour",subDomain:"min",colLimit:null,rowLimit:null,weekStartOnMonday:!0,start:new Date,minDate:null,maxDate:null,data:"",dataType:this.allowedDataType[0],considerMissingDataAsZero:!1,loadOnInit:!0,verticalOrientation:!1,domainDynamicDimension:!0,label:{position:"bottom",align:"center",offset:{x:0,y:0},rotate:null,width:100,height:null},legend:[10,20,30,40],displayLegend:!0,legendCellSize:10,legendCellPadding:2,legendMargin:[0,0,0,0],legendVerticalPosition:"bottom",legendHorizontalPosition:"left",legendOrientation:"horizontal",legendColors:null,highlight:[],itemName:["item","items"],domainLabelFormat:null,subDomainTitleFormat:{empty:"{date}",filled:"{count} {name} {connector} {date}"},subDomainDateFormat:null,subDomainTextFormat:null,legendTitleFormat:{lower:"less than {min} {name}",inner:"between {down} and {up} {name}",upper:"more than {max} {name}"},animationDuration:500,nextSelector:!1,previousSelector:!1,itemNamespace:"cal-heatmap",tooltip:!1,onClick:null,afterLoad:null,afterLoadNextDomain:null,afterLoadPreviousDomain:null,onComplete:null,afterLoadData:function(data){return data},onMaxDomainReached:null,onMinDomainReached:null},this._domainType={min:{name:"minute",level:10,maxItemNumber:60,defaultRowNumber:10,defaultColumnNumber:6,row:function(d){return self.getSubDomainRowNumber(d)},column:function(d){return self.getSubDomainColumnNumber(d)},position:{x:function(d){return Math.floor(d.getMinutes()/self._domainType.min.row(d))},y:function(d){return d.getMinutes()%self._domainType.min.row(d)}},format:{date:"%H:%M, %A %B %-e, %Y",legend:"",connector:"at"},extractUnit:function(d){return new Date(d.getFullYear(),d.getMonth(),d.getDate(),d.getHours(),d.getMinutes()).getTime()}},hour:{name:"hour",level:20,maxItemNumber:function(d){switch(self.options.domain){case"day":return 24;case"week":return 168;case"month":return 24*(self.options.domainDynamicDimension?self.getDayCountInMonth(d):31)}},defaultRowNumber:6,defaultColumnNumber:function(d){switch(self.options.domain){case"day":return 4;case"week":return 28;case"month":return self.options.domainDynamicDimension?self.getDayCountInMonth(d):31}},row:function(d){return self.getSubDomainRowNumber(d)},column:function(d){return self.getSubDomainColumnNumber(d)},position:{x:function(d){return"month"===self.options.domain?self.options.colLimit>0||self.options.rowLimit>0?Math.floor((d.getHours()+24*(d.getDate()-1))/self._domainType.hour.row(d)):Math.floor(d.getHours()/self._domainType.hour.row(d))+4*(d.getDate()-1):"week"===self.options.domain?self.options.colLimit>0||self.options.rowLimit>0?Math.floor((d.getHours()+24*self.getWeekDay(d))/self._domainType.hour.row(d)):Math.floor(d.getHours()/self._domainType.hour.row(d))+4*self.getWeekDay(d):Math.floor(d.getHours()/self._domainType.hour.row(d))},y:function(d){var p=d.getHours();if(self.options.colLimit>0||self.options.rowLimit>0)switch(self.options.domain){case"month":p+=24*(d.getDate()-1);break;case"week":p+=24*self.getWeekDay(d)}return Math.floor(p%self._domainType.hour.row(d))}},format:{date:"%Hh, %A %B %-e, %Y",legend:"%H:00",connector:"at"},extractUnit:function(d){return new Date(d.getFullYear(),d.getMonth(),d.getDate(),d.getHours()).getTime()}},day:{name:"day",level:30,maxItemNumber:function(d){switch(self.options.domain){case"week":return 7;case"month":return self.options.domainDynamicDimension?self.getDayCountInMonth(d):31;case"year":return self.options.domainDynamicDimension?self.getDayCountInYear(d):366}},defaultColumnNumber:function(d){switch(d=new Date(d),self.options.domain){case"week":return 1;case"month":return self.options.domainDynamicDimension&&!self.options.verticalOrientation?self.getWeekNumber(new Date(d.getFullYear(),d.getMonth()+1,0))-self.getWeekNumber(d)+1:6;case"year":return self.options.domainDynamicDimension?self.getWeekNumber(new Date(d.getFullYear(),11,31))-self.getWeekNumber(new Date(d.getFullYear(),0))+1:54}},defaultRowNumber:7,row:function(d){return self.getSubDomainRowNumber(d)},column:function(d){return self.getSubDomainColumnNumber(d)},position:{x:function(d){switch(self.options.domain){case"week":return Math.floor(self.getWeekDay(d)/self._domainType.day.row(d));case"month":return self.options.colLimit>0||self.options.rowLimit>0?Math.floor((d.getDate()-1)/self._domainType.day.row(d)):self.getWeekNumber(d)-self.getWeekNumber(new Date(d.getFullYear(),d.getMonth()));case"year":return self.options.colLimit>0||self.options.rowLimit>0?Math.floor((self.getDayOfYear(d)-1)/self._domainType.day.row(d)):self.getWeekNumber(d)}},y:function(d){var p=self.getWeekDay(d);if(self.options.colLimit>0||self.options.rowLimit>0)switch(self.options.domain){case"year":p=self.getDayOfYear(d)-1;break;case"week":p=self.getWeekDay(d);break;case"month":p=d.getDate()-1}return Math.floor(p%self._domainType.day.row(d))}},format:{date:"%A %B %-e, %Y",legend:"%e %b",connector:"on"},extractUnit:function(d){return new Date(d.getFullYear(),d.getMonth(),d.getDate()).getTime()}},week:{name:"week",level:40,maxItemNumber:54,defaultColumnNumber:function(d){switch(d=new Date(d),self.options.domain){case"year":return self._domainType.week.maxItemNumber;case"month":return self.getWeekNumber(new Date(d.getFullYear(),d.getMonth()+1,0))-self.getWeekNumber(d)}},defaultRowNumber:1,row:function(d){return self.getSubDomainRowNumber(d)},column:function(d){return self.getSubDomainColumnNumber(d)},position:{x:function(d){switch(self.options.domain){case"year":return Math.floor(self.getWeekNumber(d)/self._domainType.week.row(d));case"month":return Math.floor(self.getMonthWeekNumber(d)/self._domainType.week.row(d))}},y:function(d){return self.getWeekNumber(d)%self._domainType.week.row(d)}},format:{date:"%B Week #%W",legend:"%B Week #%W",connector:"on"},extractUnit:function(d){var dt=new Date(d.getFullYear(),d.getMonth(),d.getDate()),weekDay=dt.getDay()-1;return weekDay<0&&(weekDay=6),dt.setDate(dt.getDate()-weekDay),dt.getTime()}},month:{name:"month",level:50,maxItemNumber:12,defaultColumnNumber:12,defaultRowNumber:1,row:function(){return self.getSubDomainRowNumber()},column:function(){return self.getSubDomainColumnNumber()},position:{x:function(d){return Math.floor(d.getMonth()/self._domainType.month.row(d))},y:function(d){return d.getMonth()%self._domainType.month.row(d)}},format:{date:"%B %Y",legend:"%B",connector:"on"},extractUnit:function(d){return new Date(d.getFullYear(),d.getMonth()).getTime()}},year:{name:"year",level:60,row:function(){return self.options.rowLimit||1},column:function(){return self.options.colLimit||1},position:{x:function(){return 1},y:function(){return 1}},format:{date:"%Y",legend:"%Y",connector:"on"},extractUnit:function(d){return new Date(d.getFullYear()).getTime()}}},this._domainType)if(this._domainType.hasOwnProperty(type)){var d=this._domainType[type];this._domainType["x_"+type]={name:"x_"+type,level:d.type,maxItemNumber:d.maxItemNumber,defaultRowNumber:d.defaultRowNumber,defaultColumnNumber:d.defaultColumnNumber,row:d.column,column:d.row,position:{x:d.position.y,y:d.position.x},format:d.format,extractUnit:d.extractUnit}}function w(d,outer){var width=self.options.cellSize*self._domainType[self.options.subDomain].column(d)+self.options.cellPadding*self._domainType[self.options.subDomain].column(d);return 2===arguments.length&&!0===outer?width+(self.domainHorizontalLabelWidth+self.options.domainGutter+self.options.domainMargin[1]+self.options.domainMargin[3]):width}function h(d,outer){var height=self.options.cellSize*self._domainType[self.options.subDomain].row(d)+self.options.cellPadding*self._domainType[self.options.subDomain].row(d);return 2===arguments.length&&!0===outer&&(height+=self.options.domainGutter+self.domainVerticalLabelHeight+self.options.domainMargin[0]+self.options.domainMargin[2]),height}this.lastInsertedSvg=null,this._completed=!1,this._domains=d3.map(),this.graphDim={width:0,height:0},this.legendDim={width:0,height:0},this.NAVIGATE_LEFT=1,this.NAVIGATE_RIGHT=2,this.RESET_ALL_ON_UPDATE=0,this.RESET_SINGLE_ON_UPDATE=1,this.APPEND_ON_UPDATE=2,this.DEFAULT_LEGEND_MARGIN=10,this.root=null,this.tooltip=null,this._maxDomainReached=!1,this._minDomainReached=!1,this.domainPosition=new DomainPosition,this.Legend=null,this.legendScale=null,this.DSTDomain=[],this._init=function(){return self.getDomain(self.options.start).map((function(d){return d.getTime()})).map((function(d){self._domains.set(d,self.getSubDomain(d).map((function(d){return{t:self._domainType[self.options.subDomain].extractUnit(d),v:null}})))})),self.root=d3.select(self.options.itemSelector).append("svg").attr("class","cal-heatmap-container"),self.tooltip=d3.select(self.options.itemSelector).append("div").attr("class","ch-tooltip"),self.root.attr("x",0).attr("y",0).append("svg").attr("class","graph"),self.Legend=new Legend(self),self.options.paintOnLoad&&function(){self.verticalDomainLabel="top"===self.options.label.position||"bottom"===self.options.label.position,self.domainVerticalLabelHeight=null===self.options.label.height?Math.max(25,2*self.options.cellSize):self.options.label.height,self.domainHorizontalLabelWidth=0,""===self.options.domainLabelFormat&&null===self.options.label.height&&(self.domainVerticalLabelHeight=0);self.verticalDomainLabel||(self.domainVerticalLabelHeight=0,self.domainHorizontalLabelWidth=self.options.label.width);self.paint(),!1!==self.options.nextSelector&&d3.select(self.options.nextSelector).on("click."+self.options.itemNamespace,(function(){return d3.event.preventDefault(),self.loadNextDomain(1)}));!1!==self.options.previousSelector&&d3.select(self.options.previousSelector).on("click."+self.options.itemNamespace,(function(){return d3.event.preventDefault(),self.loadPreviousDomain(1)}));self.Legend.redraw(self.graphDim.width-self.options.domainGutter-self.options.cellPadding),self.afterLoad();var domains=self.getDomainKeys();self.options.loadOnInit?self.getDatas(self.options.data,new Date(domains[0]),self.getSubDomain(domains[domains.length-1]).pop(),(function(){self.fill(),self.onComplete()})):self.onComplete();self.checkIfMinDomainIsReached(domains[0]),self.checkIfMaxDomainIsReached(self.getNextDomain().getTime())}(),!0},this.paint=function(navigationDir){var options=self.options;0===arguments.length&&(navigationDir=!1);var domainSvg=self.root.select(".graph").selectAll(".graph-domain").data((function(){var data=self.getDomainKeys();return navigationDir===self.NAVIGATE_LEFT?data.reverse():data}),(function(d){return d})),enteringDomainDim=0,exitingDomainDim=0,svg=domainSvg.enter().append("svg").attr("width",(function(d){return w(d,!0)})).attr("height",(function(d){return h(d,!0)})).attr("x",(function(d){return options.verticalOrientation?(self.graphDim.width=Math.max(self.graphDim.width,w(d,!0)),0):getDomainPosition(d,self.graphDim,"width",w(d,!0))})).attr("y",(function(d){return options.verticalOrientation?getDomainPosition(d,self.graphDim,"height",h(d,!0)):(self.graphDim.height=Math.max(self.graphDim.height,h(d,!0)),0)})).attr("class",(function(d){var classname="graph-domain",date=new Date(d);switch(options.domain){case"hour":classname+=" h_"+date.getHours();case"day":classname+=" d_"+date.getDate()+" dy_"+date.getDay();case"week":classname+=" w_"+self.getWeekNumber(date);case"month":classname+=" m_"+(date.getMonth()+1);case"year":classname+=" y_"+date.getFullYear()}return classname}));function getDomainPosition(domainIndex,graphDim,axis,domainDim){var tmp=0;switch(navigationDir){case!1:return tmp=graphDim[axis],graphDim[axis]+=domainDim,self.domainPosition.setPosition(domainIndex,tmp),tmp;case self.NAVIGATE_RIGHT:return self.domainPosition.setPosition(domainIndex,graphDim[axis]),enteringDomainDim=domainDim,exitingDomainDim=self.domainPosition.getPositionFromIndex(1),self.domainPosition.shiftRightBy(exitingDomainDim),graphDim[axis];case self.NAVIGATE_LEFT:return enteringDomainDim=-(tmp=-domainDim),exitingDomainDim=graphDim[axis]-self.domainPosition.getLast(),self.domainPosition.setPosition(domainIndex,tmp),self.domainPosition.shiftLeftBy(enteringDomainDim),tmp}}self.lastInsertedSvg=svg,svg.append("rect").attr("width",(function(d){return w(d,!0)-options.domainGutter-options.cellPadding})).attr("height",(function(d){return h(d,!0)-options.domainGutter-options.cellPadding})).attr("class","domain-background");var rect=svg.append("svg").attr("x",(function(){return"left"===options.label.position?self.domainHorizontalLabelWidth+options.domainMargin[3]:options.domainMargin[3]})).attr("y",(function(){return"top"===options.label.position?self.domainVerticalLabelHeight+options.domainMargin[0]:options.domainMargin[0]})).attr("class","graph-subdomain-group").selectAll("g").data((function(d){return self._domains.get(d)})).enter().append("g");rect.append("rect").attr("class",(function(d){return"graph-rect"+self.getHighlightClassName(d.t)+(null!==options.onClick?" hover_cursor":"")})).attr("width",options.cellSize).attr("height",options.cellSize).attr("x",(function(d){return self.positionSubDomainX(d.t)})).attr("y",(function(d){return self.positionSubDomainY(d.t)})).on("click",(function(d){if(null!==options.onClick)return self.onClick(new Date(d.t),d.v)})).call((function(selection){options.cellRadius>0&&selection.attr("rx",options.cellRadius).attr("ry",options.cellRadius),null!==self.legendScale&&null!==options.legendColors&&options.legendColors.hasOwnProperty("base")&&selection.attr("fill",options.legendColors.base),options.tooltip&&(selection.on("mouseover",(function(d){var domainNode=this.parentNode.parentNode.parentNode;self.tooltip.html(self.getSubDomainTitle(d)).attr("style","display: block;"),self.tooltip.attr("style","display: block; left: "+(self.positionSubDomainX(d.t)-self.tooltip[0][0].offsetWidth/2+options.cellSize/2+parseInt(domainNode.getAttribute("x"),10))+"px; top: "+(self.positionSubDomainY(d.t)-self.tooltip[0][0].offsetHeight-options.cellSize/2+parseInt(domainNode.getAttribute("y"),10))+"px;")})),selection.on("mouseout",(function(){self.tooltip.attr("style","display:none").html("")})))})),options.tooltip||rect.append("title").text((function(d){return self.formatDate(new Date(d.t),options.subDomainDateFormat)})),""!==options.domainLabelFormat&&svg.append("text").attr("class","graph-label").attr("y",(function(d){var y=options.domainMargin[0];switch(options.label.position){case"top":y+=self.domainVerticalLabelHeight/2;break;case"bottom":y+=h(d)+self.domainVerticalLabelHeight/2}return y+options.label.offset.y*("right"===options.label.rotate&&"right"===options.label.position||"left"===options.label.rotate&&"left"===options.label.position?-1:1)})).attr("x",(function(d){var x=options.domainMargin[3];switch(options.label.position){case"right":x+=w(d);break;case"bottom":case"top":x+=w(d)/2}return"right"===options.label.align?x+self.domainHorizontalLabelWidth-options.label.offset.x*("right"===options.label.rotate?-1:1):x+options.label.offset.x})).attr("text-anchor",(function(){switch(options.label.align){case"start":case"left":return"start";case"end":case"right":return"end";default:return"middle"}})).attr("dominant-baseline",(function(){return self.verticalDomainLabel?"middle":"top"})).text((function(d){return self.formatDate(new Date(d),options.domainLabelFormat)})).call((function(selection){switch(options.label.rotate){case"right":selection.attr("transform",(function(d){var s="rotate(90), ";switch(options.label.position){case"right":s+="translate(-"+w(d)+" , -"+w(d)+")";break;case"left":s+="translate(0, -"+self.domainHorizontalLabelWidth+")"}return s}));break;case"left":selection.attr("transform",(function(d){var s="rotate(270), ";switch(options.label.position){case"right":s+="translate(-"+(w(d)+self.domainHorizontalLabelWidth)+" , "+w(d)+")";break;case"left":s+="translate(-"+self.domainHorizontalLabelWidth+" , "+self.domainHorizontalLabelWidth+")"}return s}))}})),null!==options.subDomainTextFormat&&rect.append("text").attr("class",(function(d){return"subdomain-text"+self.getHighlightClassName(d.t)})).attr("x",(function(d){return self.positionSubDomainX(d.t)+options.cellSize/2})).attr("y",(function(d){return self.positionSubDomainY(d.t)+options.cellSize/2})).attr("text-anchor","middle").attr("dominant-baseline","central").text((function(d){return self.formatDate(new Date(d.t),options.subDomainTextFormat)})),!1!==navigationDir&&domainSvg.transition().duration(options.animationDuration).attr("x",(function(d){return options.verticalOrientation?0:self.domainPosition.getPosition(d)})).attr("y",(function(d){return options.verticalOrientation?self.domainPosition.getPosition(d):0}));var tempWidth=self.graphDim.width,tempHeight=self.graphDim.height;options.verticalOrientation?self.graphDim.height+=enteringDomainDim-exitingDomainDim:self.graphDim.width+=enteringDomainDim-exitingDomainDim,domainSvg.exit().transition().duration(options.animationDuration).attr("x",(function(d){if(options.verticalOrientation)return 0;switch(navigationDir){case self.NAVIGATE_LEFT:return Math.min(self.graphDim.width,tempWidth);case self.NAVIGATE_RIGHT:return-w(d,!0)}})).attr("y",(function(d){if(!options.verticalOrientation)return 0;switch(navigationDir){case self.NAVIGATE_LEFT:return Math.min(self.graphDim.height,tempHeight);case self.NAVIGATE_RIGHT:return-h(d,!0)}})).remove(),self.resize()}};CalHeatMap.prototype={init:function(settings){"use strict";var parent=this,options=parent.options=mergeRecursive(parent.options,settings);if(function(){if(!parent._domainType.hasOwnProperty(options.domain)||"min"===options.domain||"x_"===options.domain.substring(0,2))throw new Error("The domain '"+options.domain+"' is not valid");if(!parent._domainType.hasOwnProperty(options.subDomain)||"year"===options.subDomain)throw new Error("The subDomain '"+options.subDomain+"' is not valid");if(parent._domainType[options.domain].level<=parent._domainType[options.subDomain].level)throw new Error("'"+options.subDomain+"' is not a valid subDomain to '"+options.domain+"'")}(),validateSelector(options.itemSelector,!1,"itemSelector"),-1===parent.allowedDataType.indexOf(options.dataType))throw new Error("The data type '"+options.dataType+"' is not valid data type");if(null===d3.select(options.itemSelector)[0][0])throw new Error("The node '"+options.itemSelector+"' specified in itemSelector does not exists");try{validateSelector(options.nextSelector,!0,"nextSelector"),validateSelector(options.previousSelector,!0,"previousSelector")}catch(error){return console.log(error.message),!1}settings.hasOwnProperty("subDomain")||(this.options.subDomain=function(domain){switch(domain){case"year":return"month";case"month":case"week":return"day";case"day":return"hour";default:return"min"}}(settings.domain)),"string"==typeof options.itemNamespace&&""!==options.itemNamespace||(console.log("itemNamespace can not be empty, falling back to cal-heatmap"),options.itemNamespace="cal-heatmap");var value,s=["data","onComplete","onClick","afterLoad","afterLoadData","afterLoadPreviousDomain","afterLoadNextDomain"];for(var k in s)settings.hasOwnProperty(s[k])&&(options[s[k]]=settings[s[k]]);function validateSelector(selector,canBeFalse,name){if((canBeFalse&&!1===selector||selector instanceof Element||"string"==typeof selector)&&""!==selector)return!0;throw new Error("The "+name+" is not valid")}function expandMarginSetting(value){switch("number"==typeof value&&(value=[value]),Array.isArray(value)||(console.log("Margin only takes an integer or an array of integers"),value=[0]),value.length){case 1:return[value[0],value[0],value[0],value[0]];case 2:return[value[0],value[1],value[0],value[1]];case 3:return[value[0],value[1],value[2],value[1]];case 4:return value;default:return value.slice(0,4)}}return options.subDomainDateFormat="string"==typeof options.subDomainDateFormat||"function"==typeof options.subDomainDateFormat?options.subDomainDateFormat:this._domainType[options.subDomain].format.date,options.domainLabelFormat="string"==typeof options.domainLabelFormat||"function"==typeof options.domainLabelFormat?options.domainLabelFormat:this._domainType[options.domain].format.legend,options.subDomainTextFormat="string"==typeof options.subDomainTextFormat&&""!==options.subDomainTextFormat||"function"==typeof options.subDomainTextFormat?options.subDomainTextFormat:null,options.domainMargin=expandMarginSetting(options.domainMargin),options.legendMargin=expandMarginSetting(options.legendMargin),options.highlight=parent.expandDateSetting(options.highlight),options.itemName=function(value){if("string"==typeof value)return[value,value+(""!==value?"s":"")];if(Array.isArray(value))return 1===value.length?[value[0],value[0]+"s"]:value.length>2?value.slice(0,2):value;return["item","items"]}(options.itemName),options.colLimit=(value=options.colLimit)>0?value:null,options.rowLimit=function(value){if(value>0&&options.colLimit>0)return console.log("colLimit and rowLimit are mutually exclusive, rowLimit will be ignored"),null;return value>0?value:null}(options.rowLimit),settings.hasOwnProperty("legendMargin")||function(){switch(options.legendVerticalPosition){case"top":options.legendMargin[2]=parent.DEFAULT_LEGEND_MARGIN;break;case"bottom":options.legendMargin[0]=parent.DEFAULT_LEGEND_MARGIN;break;case"middle":case"center":options.legendMargin["right"===options.legendHorizontalPosition?3:1]=parent.DEFAULT_LEGEND_MARGIN}}(),function(){if(!settings.hasOwnProperty("label")||settings.hasOwnProperty("label")&&!settings.label.hasOwnProperty("align")){switch(options.label.position){case"left":options.label.align="right";break;case"right":options.label.align="left";break;default:options.label.align="center"}"left"===options.label.rotate?options.label.align="right":"right"===options.label.rotate&&(options.label.align="left")}(!settings.hasOwnProperty("label")||settings.hasOwnProperty("label")&&!settings.label.hasOwnProperty("offset"))&&("left"!==options.label.position&&"right"!==options.label.position||(options.label.offset={x:10,y:15}))}(),this._init()},expandDateSetting:function(value){"use strict";return Array.isArray(value)||(value=[value]),value.map((function(data){return"now"===data?new Date:data instanceof Date&&data})).filter((function(d){return!1!==d}))},fill:function(svg){"use strict";var parent=this,options=parent.options;0===arguments.length&&(svg=parent.root.selectAll(".graph-domain"));var rect=svg.selectAll("svg").selectAll("g").data((function(d){return parent._domains.get(d)}));rect.transition().duration(options.animationDuration).select("rect").attr("class",(function(d){var htmlClass=parent.getHighlightClassName(d.t);return null===parent.legendScale&&(htmlClass+=" graph-rect"),null!==d.v?htmlClass+=" "+parent.Legend.getClass(d.v,null===parent.legendScale):options.considerMissingDataAsZero&&(htmlClass+=" "+parent.Legend.getClass(0,null===parent.legendScale)),null!==options.onClick&&(htmlClass+=" hover_cursor"),htmlClass})).call((function(element){if(null===parent.legendScale)return!1;element.attr("fill",(function(d){return 0===d.v&&null!==options.legendColors&&options.legendColors.hasOwnProperty("empty")?options.legendColors.empty:d.v<0&&options.legend[0]>0&&null!==options.legendColors&&options.legendColors.hasOwnProperty("overflow")?options.legendColors.overflow:parent.legendScale(Math.min(d.v,options.legend[options.legend.length-1]))}))})),rect.transition().duration(options.animationDuration).select("title").text((function(d){return parent.getSubDomainTitle(d)}))},triggerEvent:function(eventName,successArgs,skip){"use strict";return!!(3===arguments.length&&skip||null===this.options[eventName])||("function"==typeof this.options[eventName]?("function"==typeof successArgs&&(successArgs=successArgs()),this.options[eventName].apply(this,successArgs)):(console.log("Provided callback for "+eventName+" is not a function."),!1))},onClick:function(d,itemNb){"use strict";return this.triggerEvent("onClick",[d,itemNb])},afterLoad:function(){"use strict";return this.triggerEvent("afterLoad")},onComplete:function(){"use strict";var response=this.triggerEvent("onComplete",[],this._completed);return this._completed=!0,response},afterLoadPreviousDomain:function(start){"use strict";var parent=this;return this.triggerEvent("afterLoadPreviousDomain",(function(){var subDomain=parent.getSubDomain(start);return[subDomain.shift(),subDomain.pop()]}))},afterLoadNextDomain:function(start){"use strict";var parent=this;return this.triggerEvent("afterLoadNextDomain",(function(){var subDomain=parent.getSubDomain(start);return[subDomain.shift(),subDomain.pop()]}))},onMinDomainReached:function(reached){"use strict";return this._minDomainReached=reached,this.triggerEvent("onMinDomainReached",[reached])},onMaxDomainReached:function(reached){"use strict";return this._maxDomainReached=reached,this.triggerEvent("onMaxDomainReached",[reached])},checkIfMinDomainIsReached:function(date,upperBound){"use strict";this.minDomainIsReached(date)&&this.onMinDomainReached(!0),2===arguments.length&&this._maxDomainReached&&!this.maxDomainIsReached(upperBound)&&this.onMaxDomainReached(!1)},checkIfMaxDomainIsReached:function(date,lowerBound){"use strict";this.maxDomainIsReached(date)&&this.onMaxDomainReached(!0),2===arguments.length&&this._minDomainReached&&!this.minDomainIsReached(lowerBound)&&this.onMinDomainReached(!1)},formatNumber:d3.format(",g"),formatDate:function(d,format){"use strict";return arguments.length<2&&(format="title"),"function"==typeof format?format(d):d3.time.format(format)(d)},getSubDomainTitle:function(d){"use strict";if(null!==d.v||this.options.considerMissingDataAsZero){var value=d.v;return null===value&&this.options.considerMissingDataAsZero&&(value=0),this.options.subDomainTitleFormat.filled.format({count:this.formatNumber(value),name:this.options.itemName[1!==value?1:0],connector:this._domainType[this.options.subDomain].format.connector,date:this.formatDate(new Date(d.t),this.options.subDomainDateFormat)})}return this.options.subDomainTitleFormat.empty.format({date:this.formatDate(new Date(d.t),this.options.subDomainDateFormat)})},loadNextDomain:function(n){"use strict";if(this._maxDomainReached||0===n)return!1;var bound=this.loadNewDomains(this.NAVIGATE_RIGHT,this.getDomain(this.getNextDomain(),n));return this.afterLoadNextDomain(bound.end),this.checkIfMaxDomainIsReached(this.getNextDomain().getTime(),bound.start),!0},loadPreviousDomain:function(n){"use strict";if(this._minDomainReached||0===n)return!1;var bound=this.loadNewDomains(this.NAVIGATE_LEFT,this.getDomain(this.getDomainKeys()[0],-n).reverse());return this.afterLoadPreviousDomain(bound.start),this.checkIfMinDomainIsReached(bound.start,bound.end),!0},loadNewDomains:function(direction,newDomains){"use strict";var parent=this,backward=direction===this.NAVIGATE_LEFT,i=-1,total=newDomains.length,domains=this.getDomainKeys();function buildSubDomain(d){return{t:parent._domainType[parent.options.subDomain].extractUnit(d),v:null}}for(;++i<total;){if(backward&&this.minDomainIsReached(newDomains[i])){newDomains=newDomains.slice(0,i+1);break}if(!backward&&this.maxDomainIsReached(newDomains[i])){newDomains=newDomains.slice(0,i);break}}for(i=0,total=(newDomains=newDomains.slice(-this.options.range)).length;i<total;i++)this._domains.set(newDomains[i].getTime(),this.getSubDomain(newDomains[i]).map(buildSubDomain)),this._domains.remove(backward?domains.pop():domains.shift());return domains=this.getDomainKeys(),backward&&(newDomains=newDomains.reverse()),this.paint(direction),this.getDatas(this.options.data,newDomains[0],this.getSubDomain(newDomains[newDomains.length-1]).pop(),(function(){parent.fill(parent.lastInsertedSvg)})),{start:newDomains[backward?0:1],end:domains[domains.length-1]}},maxDomainIsReached:function(datetimestamp){"use strict";return null!==this.options.maxDate&&this.options.maxDate.getTime()<datetimestamp},minDomainIsReached:function(datetimestamp){"use strict";return null!==this.options.minDate&&this.options.minDate.getTime()>=datetimestamp},getDomainKeys:function(){"use strict";return this._domains.keys().map((function(d){return parseInt(d,10)})).sort((function(a,b){return a-b}))},positionSubDomainX:function(d){"use strict";var index=this._domainType[this.options.subDomain].position.x(new Date(d));return index*this.options.cellSize+index*this.options.cellPadding},positionSubDomainY:function(d){"use strict";var index=this._domainType[this.options.subDomain].position.y(new Date(d));return index*this.options.cellSize+index*this.options.cellPadding},getSubDomainColumnNumber:function(d){"use strict";if(this.options.rowLimit>0){var i=this._domainType[this.options.subDomain].maxItemNumber;return"function"==typeof i&&(i=i(d)),Math.ceil(i/this.options.rowLimit)}var j=this._domainType[this.options.subDomain].defaultColumnNumber;return"function"==typeof j&&(j=j(d)),this.options.colLimit||j},getSubDomainRowNumber:function(d){"use strict";if(this.options.colLimit>0){var i=this._domainType[this.options.subDomain].maxItemNumber;return"function"==typeof i&&(i=i(d)),Math.ceil(i/this.options.colLimit)}var j=this._domainType[this.options.subDomain].defaultRowNumber;return"function"==typeof j&&(j=j(d)),this.options.rowLimit||j},getHighlightClassName:function(d){"use strict";if(d=new Date(d),this.options.highlight.length>0)for(var i in this.options.highlight)if(this.options.highlight[i]instanceof Date&&this.dateIsEqual(this.options.highlight[i],d))return" highlight"+(this.isNow(this.options.highlight[i])?" now":"");return""},isNow:function(d){"use strict";return this.dateIsEqual(d,new Date)},dateIsEqual:function(dateA,dateB){"use strict";switch(this.options.subDomain){case"x_min":case"min":return dateA.getFullYear()===dateB.getFullYear()&&dateA.getMonth()===dateB.getMonth()&&dateA.getDate()===dateB.getDate()&&dateA.getHours()===dateB.getHours()&&dateA.getMinutes()===dateB.getMinutes();case"x_hour":case"hour":return dateA.getFullYear()===dateB.getFullYear()&&dateA.getMonth()===dateB.getMonth()&&dateA.getDate()===dateB.getDate()&&dateA.getHours()===dateB.getHours();case"x_day":case"day":return dateA.getFullYear()===dateB.getFullYear()&&dateA.getMonth()===dateB.getMonth()&&dateA.getDate()===dateB.getDate();case"x_week":case"week":case"x_month":case"month":return dateA.getFullYear()===dateB.getFullYear()&&dateA.getMonth()===dateB.getMonth();default:return!1}},getDayOfYear:d3.time.format("%j"),getWeekNumber:function(d){"use strict";return(!0===this.options.weekStartOnMonday?d3.time.format("%W"):d3.time.format("%U"))(d)},getMonthWeekNumber:function(d){"use strict";"number"==typeof d&&(d=new Date(d));var monthFirstWeekNumber=this.getWeekNumber(new Date(d.getFullYear(),d.getMonth()));return this.getWeekNumber(d)-monthFirstWeekNumber-1},getWeekNumberInYear:function(d){"use strict";"number"==typeof d&&(d=new Date(d))},getDayCountInMonth:function(d){"use strict";return this.getEndOfMonth(d).getDate()},getDayCountInYear:function(d){"use strict";return"number"==typeof d&&(d=new Date(d)),1===new Date(d.getFullYear(),1,29).getMonth()?366:365},getWeekDay:function(d){"use strict";return!1===this.options.weekStartOnMonday?d.getDay():0===d.getDay()?6:d.getDay()-1},getEndOfMonth:function(d){"use strict";return"number"==typeof d&&(d=new Date(d)),new Date(d.getFullYear(),d.getMonth()+1,0)},jumpDate:function(date,count,step){"use strict";var d=new Date(date);switch(step){case"hour":d.setHours(d.getHours()+count);break;case"day":d.setHours(d.getHours()+24*count);break;case"week":d.setHours(d.getHours()+24*count*7);break;case"month":d.setMonth(d.getMonth()+count);break;case"year":d.setFullYear(d.getFullYear()+count)}return new Date(d)},getMinuteDomain:function(d,range){"use strict";var start=new Date(d.getFullYear(),d.getMonth(),d.getDate(),d.getHours()),stop=null;return stop=range instanceof Date?new Date(range.getFullYear(),range.getMonth(),range.getDate(),range.getHours()):new Date(+start+1e3*range*60),d3.time.minutes(Math.min(start,stop),Math.max(start,stop))},getHourDomain:function(d,range){"use strict";var start=new Date(d.getFullYear(),d.getMonth(),d.getDate(),d.getHours()),stop=null;range instanceof Date?stop=new Date(range.getFullYear(),range.getMonth(),range.getDate(),range.getHours()):(stop=new Date(start)).setHours(stop.getHours()+range);var domains=d3.time.hours(Math.min(start,stop),Math.max(start,stop)),i=0,total=domains.length;for(i=0;i<total;i++)if(i>0&&domains[i].getHours()===domains[i-1].getHours()){this.DSTDomain.push(domains[i].getTime()),domains.splice(i,1);break}return"number"==typeof range&&domains.length>Math.abs(range)&&domains.splice(domains.length-1,1),domains},getDayDomain:function(d,range){"use strict";var start=new Date(d.getFullYear(),d.getMonth(),d.getDate()),stop=null;return range instanceof Date?stop=new Date(range.getFullYear(),range.getMonth(),range.getDate()):(stop=new Date(start),stop=new Date(stop.setDate(stop.getDate()+parseInt(range,10)))),d3.time.days(Math.min(start,stop),Math.max(start,stop))},getWeekDomain:function(d,range){"use strict";var weekStart;!1===this.options.weekStartOnMonday?weekStart=new Date(d.getFullYear(),d.getMonth(),d.getDate()-d.getDay()):1===d.getDay()?weekStart=new Date(d.getFullYear(),d.getMonth(),d.getDate()):0===d.getDay()?(weekStart=new Date(d.getFullYear(),d.getMonth(),d.getDate())).setDate(weekStart.getDate()-6):weekStart=new Date(d.getFullYear(),d.getMonth(),d.getDate()-d.getDay()+1);var endDate=new Date(weekStart),stop=range;return"object"!=typeof range&&(stop=new Date(endDate.setDate(endDate.getDate()+7*range))),!0===this.options.weekStartOnMonday?d3.time.mondays(Math.min(weekStart,stop),Math.max(weekStart,stop)):d3.time.sundays(Math.min(weekStart,stop),Math.max(weekStart,stop))},getMonthDomain:function(d,range){"use strict";var start=new Date(d.getFullYear(),d.getMonth()),stop=null;return stop=range instanceof Date?new Date(range.getFullYear(),range.getMonth()):(stop=new Date(start)).setMonth(stop.getMonth()+range),d3.time.months(Math.min(start,stop),Math.max(start,stop))},getYearDomain:function(d,range){"use strict";var start=new Date(d.getFullYear(),0),stop=null;return stop=range instanceof Date?new Date(range.getFullYear(),0):new Date(d.getFullYear()+range,0),d3.time.years(Math.min(start,stop),Math.max(start,stop))},getDomain:function(date,range){"use strict";switch("number"==typeof date&&(date=new Date(date)),arguments.length<2&&(range=this.options.range),this.options.domain){case"hour":var domains=this.getHourDomain(date,range);return"number"==typeof range&&domains.length<range&&(range>0?domains.push(this.getHourDomain(domains[domains.length-1],2)[1]):domains.shift(this.getHourDomain(domains[0],-2)[0])),domains;case"day":return this.getDayDomain(date,range);case"week":return this.getWeekDomain(date,range);case"month":return this.getMonthDomain(date,range);case"year":return this.getYearDomain(date,range)}},getSubDomain:function(date){"use strict";"number"==typeof date&&(date=new Date(date));var parent=this;switch(this.options.subDomain){case"x_min":case"min":return this.getMinuteDomain(date,function(date,domain){switch(domain){case"hour":return 60;case"day":return 1440;case"week":return 10080}}(0,this.options.domain));case"x_hour":case"hour":return this.getHourDomain(date,function(date,domain){switch(domain){case"day":return 24;case"week":return 168;case"month":return 24*parent.getDayCountInMonth(date)}}(date,this.options.domain));case"x_day":case"day":return this.getDayDomain(date,function(date,domain){switch(domain){case"year":return parent.getDayCountInYear(date);case"month":return parent.getDayCountInMonth(date);case"week":return 7}}(date,this.options.domain));case"x_week":case"week":return this.getWeekDomain(date,function(date,domain){if("month"===domain){var endOfMonth=new Date(date.getFullYear(),date.getMonth()+1,0),endWeekNb=parent.getWeekNumber(endOfMonth),startWeekNb=parent.getWeekNumber(new Date(date.getFullYear(),date.getMonth()));return startWeekNb>endWeekNb&&(startWeekNb=0,endWeekNb++),endWeekNb-startWeekNb+1}if("year"===domain)return parent.getWeekNumber(new Date(date.getFullYear(),11,31))}(date,this.options.domain));case"x_month":case"month":return this.getMonthDomain(date,12)}},getNextDomain:function(n){"use strict";return 0===arguments.length&&(n=1),this.getDomain(this.jumpDate(this.getDomainKeys().pop(),n,this.options.domain),1)[0]},getPreviousDomain:function(n){"use strict";return 0===arguments.length&&(n=1),this.getDomain(this.jumpDate(this.getDomainKeys().shift(),-n,this.options.domain),1)[0]},getDatas:function(source,startDate,endDate,callback,afterLoad,updateMode){"use strict";var self=this;arguments.length<5&&(afterLoad=!0),arguments.length<6&&(updateMode=this.APPEND_ON_UPDATE);var _callback=function(data){!1!==afterLoad?"function"==typeof afterLoad?data=afterLoad(data):"function"==typeof self.options.afterLoadData?data=self.options.afterLoadData(data):console.log("Provided callback for afterLoadData is not a function."):"csv"!==self.options.dataType&&"tsv"!==self.options.dataType||(data=this.interpretCSV(data)),self.parseDatas(data,updateMode,startDate,endDate),"function"==typeof callback&&callback()};switch(typeof source){case"string":if(""===source)return _callback({}),!0;switch(this.options.dataType){case"json":d3.json(this.parseURI(source,startDate,endDate),_callback);break;case"csv":d3.csv(this.parseURI(source,startDate,endDate),_callback);break;case"tsv":d3.tsv(this.parseURI(source,startDate,endDate),_callback);break;case"txt":d3.text(this.parseURI(source,startDate,endDate),"text/plain",_callback)}return!1;case"object":if(source===Object(source))return _callback(source),!1;default:return _callback({}),!0}},parseDatas:function(data,updateMode,startDate,endDate){"use strict";updateMode===this.RESET_ALL_ON_UPDATE&&this._domains.forEach((function(key,value){value.forEach((function(element,index,array){array[index].v=null}))}));var temp={},extractTime=function(d){return d.t};for(var d in data){var date=new Date(1e3*d),domainUnit=this.getDomain(date)[0].getTime();if(this.DSTDomain.indexOf(domainUnit)>=0&&this._domains.has(domainUnit-36e5)&&(domainUnit-=36e5),!isNaN(d)&&data.hasOwnProperty(d)&&this._domains.has(domainUnit)&&domainUnit>=+startDate&&domainUnit<+endDate){var subDomainsData=this._domains.get(domainUnit);temp.hasOwnProperty(domainUnit)||(temp[domainUnit]=subDomainsData.map(extractTime));var index=temp[domainUnit].indexOf(this._domainType[this.options.subDomain].extractUnit(date));updateMode===this.RESET_SINGLE_ON_UPDATE||isNaN(subDomainsData[index].v)?subDomainsData[index].v=data[d]:subDomainsData[index].v+=data[d]}}},parseURI:function(str,startDate,endDate){"use strict";return str=(str=(str=(str=str.replace(/\{\{t:start\}\}/g,startDate.getTime()/1e3)).replace(/\{\{t:end\}\}/g,endDate.getTime()/1e3)).replace(/\{\{d:start\}\}/g,startDate.toISOString())).replace(/\{\{d:end\}\}/g,endDate.toISOString())},interpretCSV:function(data){"use strict";var i,total,d={},keys=Object.keys(data[0]);for(i=0,total=data.length;i<total;i++)d[data[i][keys[0]]]=+data[i][keys[1]];return d},resize:function(){"use strict";var options=this.options,legendWidth=options.displayLegend?this.Legend.getDim("width")+options.legendMargin[1]+options.legendMargin[3]:0,legendHeight=options.displayLegend?this.Legend.getDim("height")+options.legendMargin[0]+options.legendMargin[2]:0,graphWidth=this.graphDim.width-options.domainGutter-options.cellPadding,graphHeight=this.graphDim.height-options.domainGutter-options.cellPadding;this.root.transition().duration(options.animationDuration).attr("width",(function(){return"middle"===options.legendVerticalPosition||"center"===options.legendVerticalPosition?graphWidth+legendWidth:Math.max(graphWidth,legendWidth)})).attr("height",(function(){return"middle"===options.legendVerticalPosition||"center"===options.legendVerticalPosition?Math.max(graphHeight,legendHeight):graphHeight+legendHeight})),this.root.select(".graph").transition().duration(options.animationDuration).attr("y",(function(){return"top"===options.legendVerticalPosition?legendHeight:0})).attr("x",(function(){return"middle"!==options.legendVerticalPosition&&"center"!==options.legendVerticalPosition||"left"!==options.legendHorizontalPosition?0:legendWidth}))},next:function(n){"use strict";return 0===arguments.length&&(n=1),this.loadNextDomain(n)},previous:function(n){"use strict";return 0===arguments.length&&(n=1),this.loadPreviousDomain(n)},jumpTo:function(date,reset){"use strict";arguments.length<2&&(reset=!1);var domains=this.getDomainKeys(),firstDomain=domains[0],lastDomain=domains[domains.length-1];return date<firstDomain?this.loadPreviousDomain(this.getDomain(firstDomain,date).length):reset?this.loadNextDomain(this.getDomain(firstDomain,date).length):date>lastDomain&&this.loadNextDomain(this.getDomain(lastDomain,date).length)},rewind:function(){"use strict";this.jumpTo(this.options.start,!0)},update:function(dataSource,afterLoad,updateMode){"use strict";arguments.length<2&&(afterLoad=!0),arguments.length<3&&(updateMode=this.RESET_ALL_ON_UPDATE);var domains=this.getDomainKeys(),self=this;this.getDatas(dataSource,new Date(domains[0]),this.getSubDomain(domains[domains.length-1]).pop(),(function(){self.fill()}),afterLoad,updateMode)},setLegend:function(){"use strict";var oldLegend=this.options.legend.slice(0);arguments.length>=1&&Array.isArray(arguments[0])&&(this.options.legend=arguments[0]),arguments.length>=2&&(Array.isArray(arguments[1])&&arguments[1].length>=2?this.options.legendColors=[arguments[1][0],arguments[1][1]]:this.options.legendColors=arguments[1]),(arguments.length>0&&!arrayEquals(oldLegend,this.options.legend)||arguments.length>=2)&&(this.Legend.buildColors(),this.fill()),this.Legend.redraw(this.graphDim.width-this.options.domainGutter-this.options.cellPadding)},removeLegend:function(){"use strict";return!!this.options.displayLegend&&(this.options.displayLegend=!1,this.Legend.remove(),!0)},showLegend:function(){"use strict";return!this.options.displayLegend&&(this.options.displayLegend=!0,this.Legend.redraw(this.graphDim.width-this.options.domainGutter-this.options.cellPadding),!0)},highlight:function(args){"use strict";return(this.options.highlight=this.expandDateSetting(args)).length>0&&(this.fill(),!0)},destroy:function(callback){"use strict";return this.root.transition().duration(this.options.animationDuration).attr("width",0).attr("height",0).remove().each("end",(function(){"function"==typeof callback?callback():arguments.length>0&&console.log("Provided callback for destroy() is not a function.")})),null},getSVG:function(){"use strict";for(var styles={".cal-heatmap-container":{},".graph":{},".graph-rect":{},"rect.highlight":{},"rect.now":{},"text.highlight":{},"text.now":{},".domain-background":{},".graph-label":{},".subdomain-text":{},".q0":{},".qi":{}},j=1,total=this.options.legend.length+1;j<=total;j++)styles[".q"+j]={};var e,root=this.root,whitelistStyles=["stroke","stroke-width","stroke-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-miterlimit","fill","fill-opacity","fill-rule","marker","marker-start","marker-mid","marker-end","alignement-baseline","baseline-shift","dominant-baseline","glyph-orientation-horizontal","glyph-orientation-vertical","kerning","text-anchor","shape-rendering","text-transform","font-family","font","font-size","font-weight"],filterStyles=function(attribute,property,value){-1!==whitelistStyles.indexOf(property)&&(styles[attribute][property]=value)};for(var element in styles)if(styles.hasOwnProperty(element)){var dom=(e=element,root.select(e)[0][0]);if(null!==dom)if("getComputedStyle"in window){var cs=getComputedStyle(dom,null);if(0!==cs.length)for(var i=0;i<cs.length;i++)filterStyles(element,cs.item(i),cs.getPropertyValue(cs.item(i)));else for(var k in cs)cs.hasOwnProperty(k)&&filterStyles(element,k,cs[k])}else if("currentStyle"in dom){var css=dom.currentStyle;for(var p in css)filterStyles(element,p,css[p])}}var string='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><style type="text/css"><![CDATA[ ';for(var style in styles){for(var l in string+=style+" {\n",styles[style])string+="\t"+l+":"+styles[style][l]+";\n";string+="}\n"}return string+="]]></style>",string+=(new XMLSerializer).serializeToString(this.root[0][0]),string+="</svg>"}};var DomainPosition=function(){"use strict";this.positions=d3.map()};DomainPosition.prototype.getPosition=function(d){"use strict";return this.positions.get(d)},DomainPosition.prototype.getPositionFromIndex=function(i){"use strict";var domains=this.getKeys();return this.positions.get(domains[i])},DomainPosition.prototype.getLast=function(){"use strict";var domains=this.getKeys();return this.positions.get(domains[domains.length-1])},DomainPosition.prototype.setPosition=function(d,dim){"use strict";this.positions.set(d,dim)},DomainPosition.prototype.shiftRightBy=function(exitingDomainDim){"use strict";this.positions.forEach((function(key,value){this.set(key,value-exitingDomainDim)}));var domains=this.getKeys();this.positions.remove(domains[0])},DomainPosition.prototype.shiftLeftBy=function(enteringDomainDim){"use strict";this.positions.forEach((function(key,value){this.set(key,value+enteringDomainDim)}));var domains=this.getKeys();this.positions.remove(domains[domains.length-1])},DomainPosition.prototype.getKeys=function(){"use strict";return this.positions.keys().sort((function(a,b){return parseInt(a,10)-parseInt(b,10)}))};var Legend=function(calendar){"use strict";this.calendar=calendar,this.computeDim(),null!==calendar.options.legendColors&&this.buildColors()};function mergeRecursive(obj1,obj2){"use strict";for(var p in obj2)try{obj2[p].constructor===Object?obj1[p]=mergeRecursive(obj1[p],obj2[p]):obj1[p]=obj2[p]}catch(e){obj1[p]=obj2[p]}return obj1}function arrayEquals(arrayA,arrayB){"use strict";if(!arrayB||!arrayA)return!1;if(arrayA.length!==arrayB.length)return!1;for(var i=0;i<arrayA.length;i++)if(arrayA[i]instanceof Array&&arrayB[i]instanceof Array){if(!arrayEquals(arrayA[i],arrayB[i]))return!1}else if(arrayA[i]!==arrayB[i])return!1;return!0}Legend.prototype.computeDim=function(){"use strict";var options=this.calendar.options;this.dim={width:options.legendCellSize*(options.legend.length+1)+options.legendCellPadding*options.legend.length,height:options.legendCellSize}},Legend.prototype.remove=function(){"use strict";this.calendar.root.select(".graph-legend").remove(),this.calendar.resize()},Legend.prototype.redraw=function(width){"use strict";if(!this.calendar.options.displayLegend)return!1;var legendItem,parent=this,calendar=this.calendar,legend=calendar.root,options=calendar.options;this.computeDim();var _legend=options.legend.slice(0);_legend.push(_legend[_legend.length-1]+1);var legendElement=calendar.root.select(".graph-legend");function legendCellLayout(selection){selection.attr("width",options.legendCellSize).attr("height",options.legendCellSize).attr("x",(function(d,i){return i*(options.legendCellSize+options.legendCellPadding)}))}function getLegendXPosition(){switch(options.legendHorizontalPosition){case"right":return"center"===options.legendVerticalPosition||"middle"===options.legendVerticalPosition?width+options.legendMargin[3]:width-parent.getDim("width")-options.legendMargin[1];case"middle":case"center":return Math.round(width/2-parent.getDim("width")/2);default:return options.legendMargin[3]}}function getLegendYPosition(){return"bottom"===options.legendVerticalPosition?calendar.graphDim.height+options.legendMargin[0]-options.domainGutter-options.cellPadding:options.legendMargin[0]}null!==legendElement[0][0]?legendItem=(legend=legendElement).select("g").selectAll("rect").data(_legend):((legend="top"===options.legendVerticalPosition?legend.insert("svg",".graph"):legend.append("svg")).attr("x",getLegendXPosition()).attr("y",getLegendYPosition()),legendItem=legend.attr("class","graph-legend").attr("height",parent.getDim("height")).attr("width",parent.getDim("width")).append("g").selectAll().data(_legend)),legendItem.enter().append("rect").call(legendCellLayout).attr("class",(function(d){return calendar.Legend.getClass(d,null===calendar.legendScale)})).attr("fill-opacity",0).call((function(selection){null!==calendar.legendScale&&null!==options.legendColors&&options.legendColors.hasOwnProperty("base")&&selection.attr("fill",options.legendColors.base)})).append("title"),legendItem.exit().transition().duration(options.animationDuration).attr("fill-opacity",0).remove(),legendItem.transition().delay((function(d,i){return options.animationDuration*i/10})).call(legendCellLayout).attr("fill-opacity",1).call((function(element){element.attr("fill",(function(d,i){return null===calendar.legendScale?"":0===i?calendar.legendScale(d-1):calendar.legendScale(options.legend[i-1])})),element.attr("class",(function(d){return calendar.Legend.getClass(d,null===calendar.legendScale)}))})),legendItem.select("title").text((function(d,i){return 0===i?options.legendTitleFormat.lower.format({min:options.legend[i],name:options.itemName[1]}):i===_legend.length-1?options.legendTitleFormat.upper.format({max:options.legend[i-1],name:options.itemName[1]}):options.legendTitleFormat.inner.format({down:options.legend[i-1],up:options.legend[i],name:options.itemName[1]})})),legend.transition().duration(options.animationDuration).attr("x",getLegendXPosition()).attr("y",getLegendYPosition()).attr("width",parent.getDim("width")).attr("height",parent.getDim("height")),legend.select("g").transition().duration(options.animationDuration).attr("transform",(function(){return"vertical"===options.legendOrientation?"rotate(90 "+options.legendCellSize/2+" "+options.legendCellSize/2+")":""})),calendar.resize()},Legend.prototype.getDim=function(axis){"use strict";var isHorizontal="horizontal"===this.calendar.options.legendOrientation;switch(axis){case"width":return this.dim[isHorizontal?"width":"height"];case"height":return this.dim[isHorizontal?"height":"width"]}},Legend.prototype.buildColors=function(){"use strict";var options=this.calendar.options;if(null===options.legendColors)return this.calendar.legendScale=null,!1;var _colorRange=[];if(Array.isArray(options.legendColors))_colorRange=options.legendColors;else{if(!options.legendColors.hasOwnProperty("min")||!options.legendColors.hasOwnProperty("max"))return options.legendColors=null,!1;_colorRange=[options.legendColors.min,options.legendColors.max]}var _legend=options.legend.slice(0);_legend[0]>0?_legend.unshift(0):_legend[0]<0&&_legend.unshift(_legend[0]-(_legend[_legend.length-1]-_legend[0])/_legend.length);var colorScale=d3.scale.linear().range(_colorRange).interpolate(d3.interpolateHcl).domain([d3.min(_legend),d3.max(_legend)]),legendColors=_legend.map((function(element){return colorScale(element)}));return this.calendar.legendScale=d3.scale.threshold().domain(options.legend).range(legendColors),!0},Legend.prototype.getClass=function(n,withCssClass){"use strict";if(null===n||isNaN(n))return"";for(var index=[this.calendar.options.legend.length+1],i=0,total=this.calendar.options.legend.length-1;i<=total;i++){if(this.calendar.options.legend[0]>0&&n<0){index=["1","i"];break}if(n<=this.calendar.options.legend[i]){index=[i+1];break}}return 0===n&&index.push(0),index.unshift(""),(index.join(" r")+(withCssClass?index.join(" q"):"")).trim()},String.prototype.format=function(){"use strict";var formatted=this;for(var prop in arguments[0])if(arguments[0].hasOwnProperty(prop)){var regexp=new RegExp("\\{"+prop+"\\}","gi");formatted=formatted.replace(regexp,arguments[0][prop])}return formatted},"function"==typeof define&&define.amd&&define(["d3"],(function(){"use strict";return CalHeatMap}));